commit:     5e07fccffc54abe0e18cf91fd5b430625da28561
Author:     Sam James <sam <AT> gentoo <DOT> org>
AuthorDate: Wed Jan 11 21:38:49 2023 +0000
Commit:     Sam James <sam <AT> gentoo <DOT> org>
CommitDate: Wed Jan 11 21:39:40 2023 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=5e07fccf

sys-apps/file: backport decompression fix

Signed-off-by: Sam James <sam <AT> gentoo.org>

 sys-apps/file/file-5.44-r2.ebuild                  | 171 +++++++++++++++++++++
 .../file/files/file-5.44-decompress-empty.patch    | 126 +++++++++++++++
 2 files changed, 297 insertions(+)

diff --git a/sys-apps/file/file-5.44-r2.ebuild 
b/sys-apps/file/file-5.44-r2.ebuild
new file mode 100644
index 000000000000..fd89f18309c4
--- /dev/null
+++ b/sys-apps/file/file-5.44-r2.ebuild
@@ -0,0 +1,171 @@
+# Copyright 1999-2023 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+DISTUTILS_USE_PEP517=setuptools
+DISTUTILS_OPTIONAL=1
+PYTHON_COMPAT=( python3_{8..11} )
+
+inherit distutils-r1 libtool toolchain-funcs multilib-minimal
+
+if [[ ${PV} == 9999 ]] ; then
+       EGIT_REPO_URI="https://github.com/glensc/file.git";
+       inherit autotools git-r3
+else
+       VERIFY_SIG_OPENPGP_KEY_PATH="${BROOT}"/usr/share/openpgp-keys/file.asc
+       inherit verify-sig
+       SRC_URI="ftp://ftp.astron.com/pub/file/${P}.tar.gz";
+       SRC_URI+=" verify-sig? ( ftp://ftp.astron.com/pub/file/${P}.tar.gz.asc 
)"
+
+       KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~ia64 ~loong ~m68k ~mips ~ppc 
~ppc64 ~riscv ~s390 ~x86 ~x64-cygwin ~amd64-linux ~x86-linux ~ppc-macos 
~x64-macos ~sparc-solaris ~sparc64-solaris ~x64-solaris ~x86-solaris"
+
+       BDEPEND="verify-sig? ( sec-keys/openpgp-keys-file )"
+fi
+
+DESCRIPTION="Identify a file's format by scanning binary data for patterns"
+HOMEPAGE="https://www.darwinsys.com/file/";
+
+LICENSE="BSD-2"
+SLOT="0"
+IUSE="bzip2 lzip lzma python seccomp static-libs zlib zstd"
+REQUIRED_USE="python? ( ${PYTHON_REQUIRED_USE} )"
+
+DEPEND="
+       bzip2? ( app-arch/bzip2[${MULTILIB_USEDEP}] )
+       lzip? ( app-arch/lzlib )
+       lzma? ( app-arch/xz-utils[${MULTILIB_USEDEP}] )
+       python? (
+               ${PYTHON_DEPS}
+               dev-python/setuptools[${PYTHON_USEDEP}]
+       )
+       zlib? ( >=sys-libs/zlib-1.2.8-r1[${MULTILIB_USEDEP}] )
+       zstd? ( app-arch/zstd:=[${MULTILIB_USEDEP}] )
+"
+RDEPEND="${DEPEND}
+       python? ( !dev-python/python-magic )
+       seccomp? ( sys-libs/libseccomp[${MULTILIB_USEDEP}] )"
+BDEPEND+="
+       python? (
+               ${PYTHON_DEPS}
+               ${DISTUTILS_DEPS}
+       )"
+
+PATCHES=(
+       "${FILESDIR}/file-5.43-seccomp-fstatat64-musl.patch" #789336, not 
upstream yet
+       "${FILESDIR}/file-5.43-portage-sandbox.patch" #889046
+       "${FILESDIR}/file-5.44-limits-solaris.patch" # applied upstream
+       "${FILESDIR}/file-5.44-seccomp-utimes.patch" # upstream
+       "${FILESDIR}/file-5.44-decompress-empty.patch" # upstream
+)
+
+src_prepare() {
+       default
+
+       if [[ ${PV} == 9999 ]] ; then
+               eautoreconf
+       else
+               elibtoolize
+       fi
+
+       # Don't let python README kill main README, bug ##60043
+       mv python/README.md python/README.python.md || die
+
+       # bug #662090
+       sed '[email protected]@README.python.md@' -i python/setup.py || die
+}
+
+multilib_src_configure() {
+       local myeconfargs=(
+               --enable-fsect-man5
+               $(use_enable bzip2 bzlib)
+               $(multilib_native_use_enable lzip lzlib)
+               $(use_enable lzma xzlib)
+               $(use_enable seccomp libseccomp)
+               $(use_enable static-libs static)
+               $(use_enable zlib)
+               $(use_enable zstd zstdlib)
+       )
+
+       econf "${myeconfargs[@]}"
+}
+
+build_src_configure() {
+       local myeconfargs=(
+               --disable-shared
+               --disable-libseccomp
+               --disable-bzlib
+               --disable-xzlib
+               --disable-zlib
+       )
+
+       econf_build "${myeconfargs[@]}"
+}
+
+need_build_file() {
+       # When cross-compiling, we need to build up our own file
+       # because people often don't keep matching host/target
+       # file versions, bug #362941
+       tc-is-cross-compiler && ! has_version -b "~${CATEGORY}/${P}"
+}
+
+src_configure() {
+       local ECONF_SOURCE="${S}"
+
+       if need_build_file ; then
+               mkdir -p "${WORKDIR}"/build || die
+               cd "${WORKDIR}"/build || die
+               build_src_configure
+       fi
+
+       multilib-minimal_src_configure
+}
+
+multilib_src_compile() {
+       if multilib_is_native_abi ; then
+               emake
+       else
+               # bug #586444
+               emake -C src magic.h
+               emake -C src libmagic.la
+       fi
+}
+
+src_compile() {
+       if need_build_file ; then
+               # bug #586444
+               emake -C "${WORKDIR}"/build/src magic.h
+               emake -C "${WORKDIR}"/build/src file
+               local -x PATH="${WORKDIR}/build/src:${PATH}"
+       fi
+
+       multilib-minimal_src_compile
+
+       if use python ; then
+               cd python || die
+               distutils-r1_src_compile
+       fi
+}
+
+multilib_src_install() {
+       if multilib_is_native_abi ; then
+               default
+       else
+               emake -C src install-{nodist_includeHEADERS,libLTLIBRARIES} 
DESTDIR="${D}"
+       fi
+}
+
+multilib_src_install_all() {
+       dodoc ChangeLog MAINT # README
+
+       # Required for `file -C`
+       insinto /usr/share/misc/magic
+       doins -r magic/Magdir/*
+
+       if use python ; then
+               cd python || die
+               distutils-r1_src_install
+       fi
+
+       find "${ED}" -type f -name "*.la" -delete || die
+}

diff --git a/sys-apps/file/files/file-5.44-decompress-empty.patch 
b/sys-apps/file/files/file-5.44-decompress-empty.patch
new file mode 100644
index 000000000000..21dcfa4c94c5
--- /dev/null
+++ b/sys-apps/file/files/file-5.44-decompress-empty.patch
@@ -0,0 +1,126 @@
+https://bugs.astron.com/view.php?id=415
+https://github.com/file/file/commit/1dd21dd360472d7b830825df8e40a06cdc1cbbcf
+
+From 1dd21dd360472d7b830825df8e40a06cdc1cbbcf Mon Sep 17 00:00:00 2001
+From: Christos Zoulas <[email protected]>
+Date: Sun, 8 Jan 2023 18:09:16 +0000
+Subject: [PATCH] fix decompression always returning empty.
+
+--- a/src/compress.c
++++ b/src/compress.c
+@@ -609,6 +609,7 @@ uncompresszlib(const unsigned char *old, unsigned char 
**newch,
+       int rc;
+       z_stream z;
+ 
++      DPRINTF("builtin zlib decompression\n");
+       z.next_in = CCAST(Bytef *, old);
+       z.avail_in = CAST(uint32_t, *n);
+       z.next_out = *newch;
+@@ -650,6 +651,7 @@ uncompressbzlib(const unsigned char *old, unsigned char 
**newch,
+       int rc;
+       bz_stream bz;
+ 
++      DPRINTF("builtin bzlib decompression\n");
+       memset(&bz, 0, sizeof(bz));
+       rc = BZ2_bzDecompressInit(&bz, 0, 0);
+       if (rc != BZ_OK)
+@@ -690,6 +692,7 @@ uncompressxzlib(const unsigned char *old, unsigned char 
**newch,
+       int rc;
+       lzma_stream xz;
+ 
++      DPRINTF("builtin xzlib decompression\n");
+       memset(&xz, 0, sizeof(xz));
+       rc = lzma_auto_decoder(&xz, UINT64_MAX, 0);
+       if (rc != LZMA_OK)
+@@ -729,6 +732,7 @@ uncompresszstd(const unsigned char *old, unsigned char 
**newch,
+       ZSTD_inBuffer in;
+       ZSTD_outBuffer out;
+ 
++      DPRINTF("builtin zstd decompression\n");
+       if ((zstd = ZSTD_createDStream()) == NULL) {
+               return makeerror(newch, n, "No ZSTD decompression stream, %s",
+                   strerror(errno));
+@@ -777,6 +781,7 @@ uncompresslzlib(const unsigned char *old, unsigned char 
**newch,
+ 
+       bufp = *newch;
+ 
++      DPRINTF("builtin lzlib decompression\n");
+       dec = LZ_decompress_open();
+       if (!dec) {
+               return makeerror(newch, n, "unable to allocate LZ_Decoder");
+@@ -833,11 +838,13 @@ makeerror(unsigned char **buf, size_t *len, const char 
*fmt, ...)
+       va_list ap;
+       int rv;
+ 
++      DPRINTF("Makeerror %s\n", fmt);
+       free(*buf);
+       va_start(ap, fmt);
+       rv = vasprintf(&msg, fmt, ap);
+       va_end(ap);
+       if (rv < 0) {
++              DPRINTF("Makeerror failed");
+               *buf = NULL;
+               *len = 0;
+               return NODATA;
+@@ -1048,7 +1055,7 @@ uncompressbuf(int fd, size_t bytes_max, size_t method, 
int nofork,
+       pid_t pid;
+       pid_t writepid = -1;
+       size_t i;
+-      ssize_t r;
++      ssize_t r, re;
+       char *const *args;
+ #ifdef HAVE_POSIX_SPAWNP
+       posix_spawn_file_actions_t fa;
+@@ -1103,6 +1110,7 @@ uncompressbuf(int fd, size_t bytes_max, size_t method, 
int nofork,
+ 
+       handledesc(&fa, fd, fdp);
+ 
++      DPRINTF("Executing %s\n", compr[method].argv[0]);
+       status = posix_spawnp(&pid, compr[method].argv[0], &fa, NULL,
+           args, NULL);
+ 
+@@ -1128,6 +1136,7 @@ uncompressbuf(int fd, size_t bytes_max, size_t method, 
int nofork,
+                * do not modify fdp[i][j].
+                */
+               handledesc(NULL, fd, fdp);
++              DPRINTF("Executing %s\n", compr[method].argv[0]);
+ 
+               (void)execvp(compr[method].argv[0], args);
+               dprintf(STDERR_FILENO, "exec `%s' failed, %s",
+@@ -1146,6 +1155,7 @@ uncompressbuf(int fd, size_t bytes_max, size_t method, 
int nofork,
+               if (writepid == (pid_t)-1) {
+                       rv = makeerror(newch, n, "Write to child failed, %s",
+                           strerror(errno));
++                      DPRINTF("Write to child failed\n");
+                       goto err;
+               }
+               closefd(fdp[STDIN_FILENO], 1);
+@@ -1153,6 +1163,7 @@ uncompressbuf(int fd, size_t bytes_max, size_t method, 
int nofork,
+ 
+       rv = OKDATA;
+       r = sread(fdp[STDOUT_FILENO][0], *newch, bytes_max, 0);
++      DPRINTF("read got %zd\n", r);
+       if (r < 0) {
+               rv = ERRDATA;
+               DPRINTF("Read stdout failed %d (%s)\n", fdp[STDOUT_FILENO][0],
+@@ -1165,15 +1176,17 @@ uncompressbuf(int fd, size_t bytes_max, size_t method, 
int nofork,
+                * errors, otherwise we risk the child blocking and never
+                * exiting.
+                */
++              DPRINTF("Closing stdout for bytes_max\n");
+               closefd(fdp[STDOUT_FILENO], 0);
+               goto ok;
+       }
+-      if ((r = sread(fdp[STDERR_FILENO][0], *newch, bytes_max, 0)) > 0) {
++      if ((re = sread(fdp[STDERR_FILENO][0], *newch, bytes_max, 0)) > 0) {
++              DPRINTF("Got stuff from stderr %s\n", *newch);
+               rv = ERRDATA;
+               r = filter_error(*newch, r);
+               goto ok;
+       }
+-      if  (r == 0)
++      if  (re == 0)
+               goto ok;
+       rv = makeerror(newch, n, "Read stderr failed, %s",
+           strerror(errno));
+

Reply via email to